<?php 
/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */

//  vérifie que trois entiers représentant le jour, le mois et l’annee correspondent à une date valide
$sJour = 26;
$sMois = 8;
$sAnnee = 1981; 

echo "jour/mois/annee => ".var_dump(checkdate($sMois,$sJour,$sAnnee))."<br />";// true

$sJour = 29;
$sMois = 2;
$sAnnee = 2000; 

echo "jour/mois/annee => ".var_dump(checkdate($sMois,$sJour,$sAnnee))."<br />";// true

$sJour = 29;
$sMois = 2;
$sAnnee = 2014; 

echo "jour/mois/annee => ".var_dump(checkdate($sMois,$sJour,$sAnnee))."<br /><br />";// false

// convertit en chaîne une date donnée sous la forme d’un timestamp Unix
/*
chaîne date(chaîne format[, entier timestamp])

  format : format de conversion.

  timestamp : timestamp à convertir (par défaut le timestamp actuel).

d : Jour du mois, sur deux chiffres (01 à 31)
j : Jour du mois, sur un ou deux chiffres (1 à 31)
m : Numéro du mois, sur deux chiffres (01 à 12)
n : Numéro du mois, sur un ou deux chiffres (1 à 12)
Y : Année sur quatre chiffres (2001 par exemple)
y : Année sur deux chiffres (01 par exemple)

h : Heure, au format 12h, sur deux chiffres (01 à 12)
g : Heure, au format 12h, sur un ou deux chiffres (1 à 12)
H : Heure, au format 24h, sur deux chiffres (00 à 23)
G : Heure, au format 24h, sur un ou deux chiffres (0 à 23)
i : Minutes sur deux chiffres (00 à 59)
s : Secondes sur deux chiffres (00 à 59)

z : Jour de l'annee (0 à 365)
w : Numéro du jour de la semaine (0 = dimanche à 6 = samedi)
a : Symbole "am"/"pm" (minuscules)
A : Symbole "AM"/"PM" (majuscules)
*/

echo "Date au format JJ/MM/AAAA : ". date('d/m/Y')."<br />";  
echo "Heure : ".date('H:i:s')."<br />";  
echo "Unix a fete sa milliardieme seconde le ".date('d/m/Y a H:i:s', 1000000000)."<br /><br />";  

// stocke, dans un tableau, les différentes composantes d’une date donnée sous la forme d’un timestamp Unix
/*
tableau getdate([entier timestamp])

  timestamp : Timestamp à utiliser (par défaut le timestamp actuel).

  Clé -> Valeur

seconds -> Secondes (0 à 59)
minutes -> Minutes (0 à 59)
hours -> Heures (0 à 24)

mday -> Numéro du jour du mois (1 à 31)
wday -> Numéro du jour de la semaine (0 = dimanche à 6 = samedi)

mon -> Numéro du mois (1 à 12)
year -> Année
yday -> Numéro du jour dans l’annee (0 à 365)

weekday -> Nom du jour de la semaine
month -> Nom du mois

0 -> Le timestamp
*/
$aDate = getdate(); // maintenant 
foreach($aDate as $cle => $valeur)
  echo $cle ."=>".$valeur."<br />"; 

echo "<br /><br /><br />";  
// stocke, dans un tableau, les différentes composantes d'une date donnée sous la forme d'une chaîne de caractères
/*

tableau date_parse_from_format(chaîne format, chaîne date)
  
  format : Format de la date.
  
  date : Chaîne représentant la date.


Clé -> Valeur
year -> Année
month -> Numéro du mois (1 à 12)
day -> Numéro du jour du mois (1 à 31)
hour -> Heures (0 à 24)
minute -> Minutes (0 à 59)
second -> Secondes (0 à 59)
fraction -> Fraction de seconde
warning_count -> Nombre d'’'alertes
warnings -> Tableaux des alertes
error_count -> Nombre d’erreurs
errors -> Tableau des erreurs
is_localtime -> Indique si un fuseau horaire est défini (dans ce cas, des clés supplémentaires sont présentes dans le tableau)
 */

$aDate = date_parse_from_format("d/m/Y","13/03/2013"); 
foreach($aDate as $cle => $valeur)
  echo $cle ."=>".$valeur."<br />"; 

// donne le timestamp Unix actuel
$sTime = time(); 
echo "<br /><br />timestamp Unix actuel = ".$sTime."<br/>"; 


// crée un timestamp Unix à partir des différentes composantes d'une date
/*
entier mktime([entier heure[, entier minutes[, entier secondes[, entier mois[, entier jour[, entier annee]]]]]])

heure : Heure (0 à 23).
minutes : Minutes (0 à 59).
secondes : Secondes (0 à 59).
mois : Mois (1 à 12).
jour : Jour (1 à 31).
annee : Année sur 2 ou 4 chiffres.
L'annee, sur 4 chiffres, doit être comprise entre 1902 (1970 avant la version 5.1.0) et 2038.
 */
$sTime = mktime(0,0,0,8,20,1981); 
echo "mktime(0,0,0,2,20,1981) = ".date('d/m/Y - H:i:s',$sTime)."<br/>"; 

$sTime = mktime(0,0,0,2,20+20000,1981); 
echo "20000 jours apres le 20/02/1981 = ".date('d/m/Y',$sTime)."<br/><br />"; 

// retourne le timestamp Unix actuel avec la fraction de secondes en microsecondes

// Affichage de microtime sous la forme d'une chaîne. 
echo "microtime chaine : ".microtime()."<br/>"; 

// Affichage de microtime sous la forme d'un réel. 
echo "microtime reel : ".microtime(TRUE)."<br/>"; 

// Pour ne conserver que les microsecondes, le plus simple est de transformer la chaîne en réel. 
//echo (float) microtime()."<br/>"; 


// retourne les différentes composantes (annee, mois, etc.) d'un timestamp Unix
/*
entier idate(caractère composante [,entier timestamp])

  composante : Caractère indiquant la composante souhaitée (voir ci-après).
  
  timestamp : Timestamp à utiliser (par défaut le timestamp actuel).

U : Le timestamp

Y : Année sur 4 chiffres
z : Jour de l’annee
y : Année sur 2 chiffres

m : Numéro du mois
d : Numéro du jour du mois

H : Heure sur 24
h : Heure sur 12

i : Minutes
s : Secondes

t : Nombre de jours dans le mois
L : Année bissextile (1=oui, 0=non)

Z : Décalage horaire en secondes

B : Heure Internet Swatch
I : Heure d’été (1)/Heure d’hiver (0)

W : Numéro de semaine de l’annee
w : Jour de la semaine (0 pour dimanche)

 */

// Affichage de la date/heure courante
echo strftime('%d/%m/%Y - %H:%M:%S')."<br/>";  

// Extraction de différentes composantes 
$sComposantes = str_split('YmdHistwW'); 

foreach($sComposantes as $sValue)
  echo "sValue = ",idate($sValue)."<br/><br />"; 


// retourne un nombre aléatoire entier compris entre la borne minimum et la borne maximum incluses.
/*
entier rand([entier min[, entier max]])

  min et max : Bornes des nombres aléatoires à générer.
Valeur par défaut de min = 0.
Valeur par défaut de max = une valeur donnée par la fonction getrandmax.

 */

// Génération de nombres aléatoires. 
echo rand()."<br/>"; 
echo rand()."<br/>"; 
echo rand(1, 69)."<br/>"; 
echo rand(1, 69)."<br/>";

?>
